{---------------------------------------------------------
Copyright (c) 1996-97 Massimo Maria Ghisalberti
CopyRight (c) 1996-97 MAx!
CopyRight (c) 1996-97 Objects Built for you! (O.B.you!)
Internet EMail: obyou@tin.it

name:           CryApi.pas
date:           03/20/98
version:        1 beta revision 2.

note: use at own risk.
      If you use this code, please mention O.B.you!
      somewhere in your program

IMPORTANT  : This code is only a component example, and not
             cover the whole cryptoapi, it is not full optimized
             or properly organized.

             Property Mode must be set prior to call the cipher
             routines, in this code is not present an automatic
             recognition of file format,and for this do not chiper
             with a type and decipher with another.

             InitUser = true build a default client for CSP.
             This is important for using CryptoApi.
             This is the step:
             1. build a default key container.
             2. build a digital signature in default container.
             3. build a exchange key in default container.
             See, for more info the registry database at:
             HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Cryptography.


IMPORTANTE : Il codice  solo un esempio per la possibile
             cifratura di un file data o non data una password,
              inteso a scopo educativo e per questo non
              ottimizzato od ulteriormente organizzato.

             La propriet mode deve essere settata prima di
             chiamare le routine di cifratura e decifratura,
             ogni volta, non  qui implementato un sistema
             di riconoscimento del formato del file, cifrare
             con un modo e decifrare con un altro non porter
             ai risultati sperati.

             Settare InitUser a True per creare un il client
             di default oer il CSP.le operazioni sono:
             1. crea un key container di default.
             2.  creata la firma digitale nel container
             3. la chiave di scambio  creata nel container
             vedere il registro di configurazione:
             HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Cryptography
----------------------------------------------------------}


unit CryApi;

interface

uses
  SysUtils,
  Windows,
  Classes,
  Wincrypt;

type
  TCipherMode = (cmBlock,cmStream);

type
  TCryptoApi = class(TComponent)
  private
    hSource :file;
    hDestination :file;
    EndOF :boolean;

    hProv :HCRYPTPROV;
    hKey :HCRYPTKEY;
    hXchgKey :HCRYPTKEY;
    hHash :HCRYPTHASH;

    ENCRYPT_ALGORITHM :DWORD;
    ENCRYPT_BLOCK_SIZE :DWORD;

    pbKeyBlob :PBYTE;
    dwKeyBlobLen :DWORD;

    pbBuffer :PBYTE;
    dwBlockLen :DWORD;
    dwBufferLen :DWORD;
    dwCount :DWORD;

    FSource :string;
    FDest :string;
    FPassword :string;
    FMode :TCipherMode;
    FInit :boolean;

    procedure InitAll;
    procedure CleanAll;
    procedure OpenFiles;

    procedure SetMode(Value :TCipherMode);
    procedure SetInit(value :boolean);
  protected
    function InitUserForCSP :boolean;
  public
    constructor Create(AOwner :TComponent);override;
    destructor Destroy;override;
    function Decrypt :boolean;
    function Encrypt :boolean;
  published
    property Source :string read FSource write FSource;
    property Destination :string read FDest write FDest;
    property Password :string read FPassword write FPassword;
    property Mode :TCipherMode read FMode write SetMode;
    property InitUser :boolean read FInit write SetInit;
  end;

procedure Register;

implementation

{Component Constructor}
{Costruttore del componente}
constructor TCryptoApi.Create(AOwner :TComponent);
begin
  inherited Create(AOwner);
  FInit := False;
  Mode := cmStream;
end;

{Component Destructor}
{Distruttore del componente}
destructor TCryptoApi.Destroy;
begin
  inherited Destroy;
end;

procedure TCryptoApi.SetMode(Value :TCipherMode);
begin
  case Value of
    cmBlock :
      begin
        FMode := cmBlock;
        ENCRYPT_ALGORITHM := CALG_RC2;
        ENCRYPT_BLOCK_SIZE := 8;
      end;
    cmStream :
      begin
        FMode := cmStream;
        ENCRYPT_ALGORITHM := CALG_RC4;
        ENCRYPT_BLOCK_SIZE := 1;
      end;
  end;
end;

procedure TCryptoApi.SetInit(value :boolean);
begin
  if value then
    initUserForCSP;
  FInit := False;
end;

{Initialization stage.}
{Inizializza per sicurezza le variabili}
procedure TCryptoApi.InitAll;
begin
  hProv := 0;
  hKey := 0;
  hXchgKey := 0;
  hHash := 0;
  Endof := False;
  pbKeyBlob := nil;
  pbBuffer := nil;
  dwKeyBlobLen := 0;
end;

{Clean All.}
{Ripulisce tutto.}
procedure TCryptoApi.CleanAll;
begin
  {Close files.}
  {Chiude i file.}
  CloseFile(hSource);
  CloseFile(hDestination);
  {Free Memory.}
  {Libera la memoria.}
  if pbKeyBlob <> nil then
    Dispose(pbKeyBlob);
  if pbBuffer <> nil then
    Dispose(pbBuffer);
  {Destroy Session Key.}
  {Distrugge la chiave di sessione.}
  if boolean(hKey) then
    CryptDestroyKey(hKey);
  {Close Exchange Key.}
  {Elimina l'handle della chiave di scambio.}
  if boolean(hXchgKey) then
    CryptDestroyKey(hXchgKey);
  {Destroy Hash.}
  {Distrugge l'oggetto hash.}
  if boolean(hHash) then
    CryptDestroyHash(hHash);
  {Close CSP Handle.}
  {Rilascia l'handle al CSP.}
  if boolean(hProv) then
    CryptReleaseContext(hProv,0);
end;

{Open source file and destination file.}
{La routine apre i file sorgente e di destinazione.}
procedure TCryptoApi.OpenFiles;
begin
  {Open source file.}
  {Apre il file sorgente.}
  AssignFile(hSource,FSource);
  Reset(hSource,1);
  {Open destination file.}
  {Apre il file di destinazione.}
  AssignFile(hDestination,FDest);
  Rewrite(hDestination,1);
end;

{The function create a key container and initiate CSP.}
{La funzione inizializza il sistema per l'utilizzo
 del CSP, creando un Key container.}

function TCryptoApi.InitUserForCSP :boolean;
var
  szUserName :PChar;
  dwUserNameLen :DWORD;

begin
  Result := False;
  InitAll;
  dwUserNameLen := 100;
  szUserName := StrAlloc(dwUserNameLen);
  {Try to acquire an handle to CSP.}
  {Cerca di aquisire un handle a al CSP.}
  if not CryptAcquireContext(@hProv,nil,nil,PROV_RSA_FULL,0) then
    begin
      {If error then exit from routine.}
      {In caso di errore esce dalla routine.}
      if not CryptAcquireContext(@hProv,nil,nil,PROV_RSA_FULL,CRYPT_NEWKEYSET) then
        Exit;
      {Try to acquire default key container.}
      {Prende il nome del Key container di Default.}
      if not CryptGetProvParam(hProv,PP_CONTAINER,PBYTE(szUserName),@dwUserNameLen,0) then
        {Error.}
        {Errore.}
        szUserName[0] := char(0);
      Windows.MessageBox(0,szUserName, 'Key Container...',MB_OK);
    end;
  {Try to acquire an Handle for signature.}
  {Cerca di ottenere l'handle alla firma.}
  if not CryptGetUserKey(hProv,AT_SIGNATURE,@hKey) then
    begin
      if GetLastError = NTE_NO_KEY then
        begin
          {Build signature.}
          {Crea la firma.}
          if not CryptGenKey(hProv,AT_SIGNATURE,0,@hKey) then
            begin
              Windows.MessageBox(0, 'Error during CryptGenKey', 'Error...',MB_OK);
              Exit;
            end
          else
            CryptDestroyKey(hKey);
        end
      else
        begin
          Windows.MessageBox(0, 'Error during CryptGetUserKey', 'Error...',MB_OK);
          Exit;
        end;
    end;
  {Try to acquire handle for exporting key.}
  {Cerca di ottenere l'handle per l'esportazione della chiave.}
  if not CryptGetUserKey(hProv,AT_KEYEXCHANGE,@hKey) then
    begin
      if GetLastError = NTE_NO_KEY then
        begin
          {Build exchange key.}
          {Crea la chiave di scambio.}
          if not CryptGenKey(hProv,AT_KEYEXCHANGE,0,@hKey) then
            begin
              Windows.MessageBox(0, 'Error during CryptGenKey', 'Error...',MB_OK);
              Exit;
            end
          else
            CryptDestroyKey(hKey);
        end
      else
        begin
          Windows.MessageBox(0, 'Error during CryptGetUserKey', 'Error...',MB_OK);
          Exit;
        end;
    end;
  CryptReleaseContext(hProv,0);
  StrDispose(szUserName);
  Result := True;
  {If in Form Designer...}
  {Se nel Form Designer...}
  if csDesigning in ComponentState then
    Windows.MessageBox(0, 'Success Init User', 'Message...',MB_OK);
end;

function TCryptoApi.Decrypt :boolean;
begin
  InitAll;

  Result := False;

  OpenFiles;
  {Try to acquire handle to CSP.}
  {Ricava l'handle al CSP.}
  if not CryptAcquireContext(@hProv,nil,nil,PROV_RSA_FULL,0) then
    begin
      Windows.MessageBox(0, 'Error during CryptAcquireContext', 'Error...',MB_OK);
      CleanAll;
      Exit;
    end;

  if FPassword = '' then
    begin
      {Decrypt the file with a password saved into.}
      {Decifra il file con la chiave salvata dentro.}

      {Read Key Blob from file.}
      {Legge il Key Blob dal file.}
      BlockRead(hSource,dwKeyBlobLen,1);

      try
        GetMem(pbKeyBlob,dwKeyBlobLen);
      except
        on EOutOfMemory do CleanAll;
      end;

      BlockRead(hSource,pbKeyBlob^,dwKeyBlobLen);
      {Import Key Blob in CSP.}
      {Importa il Key Blob nel CSP.}
      if not CryptImportKey(hProv,pbKeyBlob,dwKeyBlobLen,0,0,@hKey) then
        begin
          Windows.MessageBox(0, 'Error during CryptImportKey', 'Error...',MB_OK);
          CleanAll;
          Exit;
        end;
    end
  else
    begin
      {Decrypt with a session key derived from password.}
      {Decifra con la chiave di sessione derivata dalla password.}

      {Build Hash.}
      {Crea l'oggetto hash.}
      if not CryptCreateHash(hProv,CALG_MD5,0,0,@hHash) then
        begin
          Windows.MessageBox(0, 'Error during CryptCreateHash', 'Error...',MB_OK);
          CleanAll;
          Exit;
        end;
      {Obtain hash data from password.}
      {Ricava il valore Hash dalla password.}
      if not CryptHashData(hHash,PBYTE(FPassword),Length(FPassword),0) then
        begin
          Windows.MessageBox(0, 'Error during CryptHashData', 'Error...',MB_OK);
          CleanAll;
          Exit;
        end;
      {Derive session key from hash.}
      {Deriva la chiave di sessione dal oggetto hash.}
      if not CryptDeriveKey(hProv,ENCRYPT_ALGORITHM,hHash,0,@hKey) then
        begin
          Windows.MessageBox(0, 'Error during CryptDeriveKey', 'Error...',MB_OK);
          CleanAll;
          Exit;
        end;
      {Destroy hash.}
      {Distrugge l'hash.}
      CryptDestroyHash(hHash);
      hHash := 0;
    end;
  {Block of bytes for ciphering, block is a multiple of ENCRYPT_BLOCK_SIZE.}
  {Determina il numero di byte da cifrare alla volta questo deve essere
   un multiplo di ENCRYPT_BLOCK_SIZE.}
  dwBlockLen := 1000 - 1000 mod ENCRYPT_BLOCK_SIZE;
  {If using a block cipher you must add ENCRYPT_BLOCK_SIZE.}
  {Determina il blocco, se  usata la cifratura a blocchi
   occorre aggiungere dello spazio.}
  if ENCRYPT_BLOCK_SIZE > 1 then
    dwBufferLen := dwBlockLen + ENCRYPT_BLOCK_SIZE
  else
    dwBufferLen := dwBlockLen;
  {Memory allocation.}
  {Alloca la memoria.}
  try
    GetMem(pbBuffer,dwBufferLen);
  except
    on EOutOfMemory do CleanAll;
  end;
  {Decrypt source file and write in destination file.}
  {Decifra il file sorgente e scrive nella destinazione.}
  repeat
    {Read until dwBlockLen bytes from source file.}
    {legge fino a dwBlockLen byte dal file sorgente.}
    BlockRead(hSource,pbBuffer^,dwBlockLen,dwCount);
    Endof := Eof(hSource);
    {Decrypt data.}
    {Decifra i dati.}
    if not CryptDecrypt(hKey,0,Endof,0,pbBuffer,@dwCount) then
      begin
        Windows.MessageBox(0, 'Error during CryptDecrypt', 'Error...',MB_OK);
        CleanAll;
        Exit;
      end;
    BlockWrite(hDestination,pbBuffer^,dwCount);
  until Eof(hSource);
  Result := True;
  CleanAll;
end;


function TCryptoApi.Encrypt :boolean;
begin
  InitAll;

  Result := False;

  OpenFiles;
  {Obtain CSP handle.}
  {Ottiene l'handle al CSP.}
  if not CryptAcquireContext(@hProv,nil,nil,PROV_RSA_FULL,0) then
    begin
      Windows.MessageBox(0, 'Error during CryptAcquireContext', 'Error...',MB_OK);
      CleanAll;
      Exit;
    end;

  if FPassword = '' then
    begin
      {Crypt with random key.}
      {Cifra con una chive casuale.}
      if not CryptGenKey(hProv,ENCRYPT_ALGORITHM,CRYPT_EXPORTABLE,@hKey) then
        begin
          Windows.MessageBox(0, 'Error during CryptGenKey', 'Error...',MB_OK);
          CleanAll;
          Exit;
        end;
      {take exchange key handle.}
      {Prende l'handle alla chiave di scambio}
      if not CryptGetUserKey(hProv,AT_KEYEXCHANGE,@hXchgKey) then
        begin
          Windows.MessageBox(0, 'Error during CryptGetUserKey', 'Error...',MB_OK);
          CleanAll;
          Exit;
        end;
      {Calculate the key blob length and alloc a memory pool.}
      {Determina la grandezza del Key Blob ed alloca la memoria.}
      if not CryptExportKey(hKey,hXchgKey,SIMPLEBLOB,0,nil,@dwKeyBlobLen) then
        begin
          Windows.MessageBox(0, 'Error during CryptExportKey', 'Error...',MB_OK);
          CleanAll;
          Exit;
        end;

      try
        GetMem(pbKeyBlob,dwKeyBlobLen);
      except
        on EOutOfMemory do CleanAll;
      end;
      {Export session key in key blob.}
      {Esporta la chiave di sessione nel Key Blob.}
      if not CryptExportKey(hKey,hXchgKey,SIMPLEBLOB,0,pbKeyBlob,@dwKeyBlobLen) then
        begin
          Windows.MessageBox(0, 'Error during CryptExportKey', 'Error...',MB_OK);
          CleanAll;
          Exit;
        end;
      {Free the handle used for exchange keys.}
      {Rilascia l'handle per lo scambio delle chiavi.}
      CryptDestroyKey(hXchgKey);
      hXchgKey := 0;

      BlockWrite(hDestination,dwKeyBlobLen,1);
      BlockWrite(hDestination,pbKeyBlob^,dwKeyBlobLen);
    end
  else
    begin
      {Crypt with session key derived from password.}
      {Cifra con la chiave di sessione derivata dalla password.}
      {Crea l'oggetto hash}
      if not CryptCreateHash(hProv,CALG_MD5,0,0,@hHash) then
        begin
          Windows.MessageBox(0, 'Error during CryptCreateHash', 'Error...',MB_OK);
          CleanAll;
          Exit;
        end;
      {Hashing on password value.}
      {Applica l'hash sulla password.}
      if not CryptHashData(hHash,PBYTE(FPassword),Length(FPassword),0) then
        begin
          Windows.MessageBox(0, 'Error during CryptHashData', 'Error...',MB_OK);
          CleanAll;
          Exit;
        end;
      {Derive session key from hash.}
      {Deriva la chiave di sessione dall'hash.}
      if not CryptDeriveKey(hProv,ENCRYPT_ALGORITHM,hHash,0,@hKey) then
        begin
          Windows.MessageBox(0, 'Error during CryptDeriveKey', 'Error...',MB_OK);
          CleanAll;
          Exit;
        end;
      {Destroy hash.}
      {distrugge l'hash.}
      CryptDestroyHash(hHash);
      hHash := 0;
    end;
  {Block of bytes for ciphering, block is a multiple of ENCRYPT_BLOCK_SIZE.}
  {Determina il numero di byte da cifrare alla volta questo deve essere
   un multiplo di ENCRYPT_BLOCK_SIZE.}
  dwBlockLen := 1000 - 1000 mod ENCRYPT_BLOCK_SIZE;
  {If using a block cipher you must add ENCRYPT_BLOCK_SIZE.}
  {Determina il blocco, se  usata la cifratura a blocchi
   occorre aggiungere dello spazio.}
  if ENCRYPT_BLOCK_SIZE > 1 then
    dwBufferLen := dwBlockLen + ENCRYPT_BLOCK_SIZE
  else
    dwBufferLen := dwBlockLen;
  {Memory allocation.}
  {Alloca memoria.}
  try
    GetMem(pbBuffer,dwBufferLen);
  except
    on EOutOfMemory do CleanAll;
  end;
  {Crypt file.}
  {Cifra il file.}
  repeat
    {Read until dwBlockLen bytes from source file.}
    {Legge fino a dwBlockLen byte dal file sorgente}
    BlockRead(hSource,pbBuffer^,dwBlockLen,dwCount);
    Endof := Eof(hSource);
    {Cifra i dati}
    if not CryptEncrypt(hKey,0,Endof,0,pbBuffer,@dwCount,dwBufferLen) then
      begin
        Windows.MessageBox(0, 'Error during CryptEncrypt', 'Error...',MB_OK);
        CleanAll;
        Exit;
      end;
    BlockWrite(hDestination,pbBuffer^,dwCount);
  until Eof(hSource);
  Result := True;
  CleanAll;
end;


procedure Register;
begin
  RegisterComponents('Samples', [TCryptoApi]);
end;

end.

