{This document is Copyright  1997-98 Project JEDI.
Visit the JEDI home page at: http://www.delphi-jedi.org/}

{-------------------------------------------------------------------------------
Copyright (c) 1996-98 Massimo Maria Ghisalberti
CopyRight (c) 1996-98 MAx!
CopyRight (c) 1996-98 Objects Built for you! (O.B.you!)
Internet EMail: obyou@tin.it

name:           EnumAlgs.dpr
date:           08/26/1998
version:        1 beta .

note: use at own risk.
      If you use this code, please mention O.B.you!
      somewhere in your program
--------------------------------------------------------------------------------

Enumerate Algorithms
--------------------

The ENUMALGS sample is a console application that lists the algorithms
supported by the default PROV_RSA_FULL provider. By default, this will
be the Microsoft RSA Base Provider, which is included along with the
operating system.

Note that the INITUSER sample (or equivalent) must be run prior to running
these samples, in order to create a key container for the default user.

In addition to listing the name of each supported algorithm, this sample
also lists:

  - The type of algorithm (encryption, hash, key exchange, or signature).

  - The key length used by the algorithm (or number of bits in the
    hash value for hash algorithms).

  - The algorithm identifier for the algorithm. This value can be passed
    to the appropriate CryptoAPI function in order to create a key or
    hash object that makes use of the particular algorithm.

The guts of this sample can be used by applications that want to display
a list of available applications to the user.
--------------------------------------------------------------------------------}

{$APPTYPE CONSOLE}
program enumalgs;
uses 
  Windows, Wincrypt;

type
  PALG_ID = ^ALG_ID;

var
  hProv      :HCRYPTPROV = 0;
  ptr        :PChar;//:PBYTE = nil;
  index      :integer = -1;
  aiAlgid    :ALG_ID;
  dwBits     :DWORD;
  dwNameLen  :DWORD;
  szName     :array[0..99] of char;   // Often allocated dynamically.
  pbData     :array[0..999] of PBYTE;  // Often allocated dynamically.
  dwDataLen  :DWORD;
  dwFlags    :DWORD;
  pszAlgType :PChar = nil;
  args       :array[0..3] of Pointer;

function FormatMsgToCon(lpOut :PChar; arglist :va_list ):DWORD;
var
  OutMsgBuff :array[0..255] of char;
begin
  Result := wvsprintf(@OutMsgBuff,lpOut,arglist);
  Write(OutMsgBuff);
end;

function NomoreItems :boolean;
begin
  Result := false;
  {Retrieve information about an algorithm.}
	dwDataLen := 1000;
	if not(CryptGetProvParam(hProv, PP_ENUMALGS, @pbData, @dwDataLen, 0)) then
	  if(GetLastError= ERROR_NO_MORE_ITEMS) then
		 Result := true
	  else
	    begin
	      WriteLn('Error on reading Algorithm!');
	      Halt;
	    end;
end;
  
begin
  {Get handle to the default provider.}
  if not CryptAcquireContext(@hProv,nil,nil,PROV_RSA_FULL,0) then
    begin
      WriteLn('Error on getting handle to default provider.');
      Exit;
    end;
      
  {Enumerate the supported algorithms.}
  repeat
    Inc(Index);
    if Index = 0 then {Set the CRYPT_FIRST flag the first time through the loop.}
      dwFlags := CRYPT_FIRST
    else
      begin
        dwFlags := 0;
        {Extract algorithm information from 'pbData' buffer.}
	     ptr := @pbData;
	
        aiAlgid := PALG_ID(ptr)^;
        ptr := ptr + sizeof(ALG_ID);
   
        dwBits := PDWORD(ptr)^;
        ptr := ptr + sizeof(DWORD);
    
        dwNameLen := PALG_ID(ptr)^;
        ptr := ptr + sizeof(DWORD);
    
        //StrLCopy(szName, ptr,dwNameLen);
        lstrcpyn(szName, ptr,dwNameLen);
    
       case GET_ALG_CLASS(aiAlgid) of
         ALG_CLASS_DATA_ENCRYPT: pszAlgType := 'Encrypt  ';
	      ALG_CLASS_HASH:	        pszAlgType := 'Hash     ';
	      ALG_CLASS_KEY_EXCHANGE: pszAlgType := 'Exchange ';
	      ALG_CLASS_SIGNATURE:	  pszAlgType := 'Signature';
	      else
	  	     pszAlgType := 'Unknown  ';
       end;

      args[0] :=@szName;
      args[1] :=pszAlgType;
      args[2] :=Pointer(dwBits);
      args[3] :=Pointer(aiAlgid);
      FormatMsgToCon('Name: %-14s Type: %s  Bits: %-4d Algid: %8.8xhex'+#13#10, @args);
	 end;
  until NomoreItems;
   
  if boolean(hProv) then 
    CryptReleaseContext(hProv,0); 
end.